/*
 * canonical_construction_path.c
 */

#include "general.h"

// Deze twee methodes heb je misschien niet nodig

int max_min_degree(int n) {
    double max = C * log10(10) / log10(2) + 2;
    int k = max;
    return k;
}

void get_canonical_labeling(mygraph * h) {
    mygraph_to_sg(&sg, h);
    converted_to_sg = 1;
    number_of_permutations = 0;
    options.getcanon = TRUE;
    sparsenauty(&sg, lab, ptn, orbits, &options, &stats, &canonsg);
}

/*
 * Methode die checkt of je een boog kan toevoegen zonder sowieso een tweede cykel te maken.
 * Zal enkel nuttig zijn voor UH (of mss voor meer cykels als je al aan het maximum zit?)
 * Varianten voor triangle free en square free
 */


int allowed_to_add(mygraph * h, int i, int j) {
    int n = h->n;
    if (adjacent(h, i, j)) {
        return 0;
    }
    if (triangle_free && (h->edges[i] & h->edges[j])) {
        return 0;
    }
    if ((h->deg[i] == maxdeg || h->deg[j] == maxdeg)) {
        return 0;
    }
    if (max_number_of_cycles == 1 && (adjacent(h, (i + 1) % n, (j + 1) % n) || adjacent(h, (i + n - 1) % n, (j + n - 1) % n))) {
        return 0;
    }
    if (square_free) {
        int d = h->deg[i];
        int k;
        for (k = 0; k < d; k++) {
            if (h->edges[h->neighbours[i][k]] & h->edges[j]) {
                return 0;
            }
        }
    }
    return 1;
}

/*
 * Telt hoeveel cykels er door een gegeven boog gaan.
 * Voor UH altijd max=0 doen, dan stopt hij met zoeken vanaf hij één cykel heeft gevonden.
 * Voor grafen met maximaal M cykels moet je max = M - (huidig aantal cykels van h) doen.
 */
int cycle_with_given_edge(mygraph * h, int v, int w, int max) {
    if (max < 0) {
        max = 0;
    }
    int n = h->n;
    
    if(n <= 2) //Can't have any cycles
        return 0;
    
    int degrees[n];
    memcpy(degrees, h -> deg, n * sizeof (int));
    int j;
    for (j = 0; j < (h->deg[v]); j++) {
        degrees[h->neighbours[v][j]]--;
    }
    unsigned long long int cycle = BIT(v) | BIT(w);
    int cycle2[n];
    cycle2[0] = v;
    cycle2[1] = w;
    number_of_hamiltonian_cycles = 0;
    int b = build_ham_cycle(h, cycle, cycle2, v, w, degrees, 0, max, 2);
    return b;
}

int n_min_one_cycle_with_given_edge(mygraph * h, int v, int w, int max) {
    int n = h->n;
    int degrees[n];
    memcpy(degrees, h -> deg, n * sizeof (int));
    int j;
    for (j = 0; j < (h->deg[v]); j++) {
        degrees[h->neighbours[v][j]]--;
    }
    unsigned long long int cycle = BIT(v) | BIT(w);
    int cycle2[n];
    cycle2[0] = v;
    cycle2[1] = w;
    number_of_hamiltonian_cycles = 0;
    int b = build_n_min_one_cycle(h, cycle, cycle2, v, w, degrees, 0, max, 3);
    return b;
}

// Slaat generatoren op in permutations

void save_generators(int count, permutation perm[], nvector orbits[], int numorbits, int stabvertex, int n) {
    memcpy(permutations + number_of_permutations, perm, sizeof (permutation) * n);
    number_of_permutations++;
}

// Initialiseert grafen sg en canonsg en maakt geheugen vrij

void initialize_graphs(int n) {
    SG_INIT(sg);
    SG_ALLOC(sg, n, n * (n - 1), "malloc");

    SG_INIT(canonsg);
    SG_ALLOC(canonsg, n, n * (n - 1), "malloc");
}

int is_planar(mygraph * h) {
    int ne = h->e;
    int n = h->n;

    if (!converted_to_sg) {
        mygraph_to_sg(&sg, h);
    }
    converted_to_sg = 1;
    /*
DYNALLSTAT(t_ver_sparse_rep,V,V_sz);
DYNALLSTAT(t_adjl_sparse_rep,A,A_sz);
DYNALLOC1(t_ver_sparse_rep, V, V_sz, nv, "planarg");
DYNALLOC1(t_adjl_sparse_rep, A, A_sz, 2 * ne + 1, "planarg");
     */
    t_ver_sparse_rep V[n];
    t_adjl_sparse_rep A[2 * ne + 1];

    int k = 0;
    int i, j;
    for (i = 0; i < n; ++i)
        if (sg.d[i] == 0)
            V[i].first_edge = NIL;
        else {
            V[i].first_edge = k;
            for (j = sg.v[i]; j < sg.v[i] + sg.d[i]; ++j) {
                A[k].end_vertex = sg.e[j];
                A[k].next = k + 1;
                ++k;
            }
            A[k - 1].next = NIL;
        }

    if (k != 2 * ne) {
        fprintf(stderr, "Error: decoding error (planarg)\n");
        exit(1);
    }

    int nbr_c;
    int edge_pos, v, w;
    t_dlcl **dfs_tree, **back_edges, **mult_edges;
    t_ver_edge *embed_graph;

    int ans = sparseg_adjl_is_planar(V, n, A, &nbr_c,
            &dfs_tree, &back_edges, &mult_edges,
            &embed_graph, &edge_pos, &v, &w);


    sparseg_dlcl_delete(dfs_tree, n);
    sparseg_dlcl_delete(back_edges, n);
    sparseg_dlcl_delete(mult_edges, n);
    embedg_VES_delete(embed_graph, n);

    return ans;
}

/*
 * Vanaf hier lees je best van onder naar boven.
 */

int count_squares(mygraph * h, int v, int w) {
    int i;
    int number_of_squares = 0;
    int d = h->deg[v];
    for (i = 0; i < d; i++) {
        if (h->neighbours[v][i] != w) {
            number_of_squares += POPC(h->edges[w] & h->edges[h->neighbours[v][i]]) - 1;
        }
    }
    return number_of_squares;
}

int max_number_of_squares(mygraph * h, int * edges, int * number_of_edges, int v, int w) {
    int squares_edge_added = count_squares(h, v, w);
    int max = squares_edge_added;
    int k, number_of_squares;
    int l = 0;
    for (k = 0; k<*number_of_edges; k++) {
        number_of_squares = count_squares(h, number_to_edge[edges[k]][0], number_to_edge[edges[k]][1]);
        if (number_of_squares > squares_edge_added) {
            return 0;
        }
        if (number_of_squares > max) {
            max = number_of_squares;
            l = 1;
            edges[0] = edges[k];
        } else {
            if (number_of_squares == max) {
                edges[l++] = edges[k];
            }
        }
    }
    *number_of_edges = l;
    return 1;
}

int min_number_of_squares(mygraph * h, int * edges, int * number_of_edges, int v, int w) {
    int squares_edge_added = count_squares(h, v, w);
    int min = squares_edge_added;
    int k, number_of_squares;
    int l = 0;
    for (k = 0; k<*number_of_edges; k++) {
        number_of_squares = count_squares(h, number_to_edge[edges[k]][0], number_to_edge[edges[k]][1]);
        if (number_of_squares < squares_edge_added) {
            return 0;
        }
        if (number_of_squares < min) {
            min = number_of_squares;
            l = 1;
            edges[0] = edges[k];
        } else {
            if (number_of_squares == min) {
                edges[l++] = edges[k];
            }
        }
    }
    *number_of_edges = l;
    return 1;
}

int max_deg_opposite_nodes(mygraph * h, int * edges, int * number_of_edges, int v, int w) {
    int i, j, k;
    int n = h->n;
    int max_1 = 2;
    int max_2 = 2;
    double deg_1, deg_2;
    int deg_1_edge_added = MAX((h->deg[((v + n / 2) % n)] + h->deg[((v - n / 2 + n) % n)]) / 2, (h->deg[((w + n / 2) % n)] + h->deg[((w - n / 2 + n) % n)]) / 2);
    int deg_2_edge_added = MIN((h->deg[((v + n / 2) % n)] + h->deg[((v - n / 2 + n) % n)]) / 2, (h->deg[((w + n / 2) % n)] + h->deg[((w - n / 2 + n) % n)]) / 2);
    int l = 0;
    for (k = 0; k<*number_of_edges; k++) {
        i = number_to_edge[edges[k]][0];
        j = number_to_edge[edges[k]][1];
        deg_1 = MAX((h->deg[((i + n / 2) % n)] + h->deg[((i - n / 2 + n) % n)]) / 2, (h->deg[((j + n / 2) % n)] + h->deg[((j - n / 2 + n) % n)]) / 2);
        if (deg_1 > deg_1_edge_added) {
            return 0;
        }
        deg_2 = MIN((h->deg[((i + n / 2) % n)] + h->deg[((i - n / 2 + n) % n)]) / 2, (h->deg[((j + n / 2) % n)] + h->deg[((j - n / 2 + n) % n)]) / 2);
        if (deg_1 > max_1) {
            max_1 = deg_1;
            max_2 = deg_2;
            l = 1;
            edges[0] = edges[k];
        } else {
            if (deg_1 == deg_1_edge_added && deg_2 > deg_2_edge_added) {
                return 0;
            }
            if (deg_1 == max_1) {
                if (deg_2 > max_2) {
                    max_2 = deg_2;
                    l = 1;
                    edges[0] = edges[k];
                } else {
                    if (deg_2 == max_2) {
                        edges[l] = edges[k];
                        l++;
                    }
                }
            }
        }
    }
    *number_of_edges = l;
    return 1;
}

int min_deg_opposite_nodes(mygraph * h, int * edges, int * number_of_edges, int v, int w) {
    int i, j, k;
    int n = h->n;
    double deg_1, deg_2;
    int deg_1_edge_added = MIN((h->deg[((v + n / 2) % n)] + h->deg[((v - n / 2 + n) % n)]) / 2, (h->deg[((w + n / 2) % n)] + h->deg[((w - n / 2 + n) % n)]) / 2);
    int deg_2_edge_added = MAX((h->deg[((v + n / 2) % n)] + h->deg[((v - n / 2 + n) % n)]) / 2, (h->deg[((w + n / 2) % n)] + h->deg[((w - n / 2 + n) % n)]) / 2);
    int min_1 = deg_1_edge_added;
    int min_2 = deg_2_edge_added;
    int l = 0;
    for (k = 0; k<*number_of_edges; k++) {
        i = number_to_edge[edges[k]][0];
        j = number_to_edge[edges[k]][1];
        deg_1 = MIN((h->deg[((i + n / 2) % n)] + h->deg[((i - n / 2 + n) % n)]) / 2, (h->deg[((j + n / 2) % n)] + h->deg[((j - n / 2 + n) % n)]) / 2);
        if (deg_1 < deg_1_edge_added) {
            return 0;
        }
        deg_2 = MAX((h->deg[((i + n / 2) % n)] + h->deg[((i - n / 2 + n) % n)]) / 2, (h->deg[((j + n / 2) % n)] + h->deg[((j - n / 2 + n) % n)]) / 2);
        if (deg_1 < min_1) {
            min_1 = deg_1;
            min_2 = deg_2;
            l = 1;
            edges[0] = edges[k];
        } else {
            if (deg_1 == deg_1_edge_added && deg_2 < deg_2_edge_added) {
                return 0;
            }
            if (deg_1 == min_1) {
                if (deg_2 < min_2) {
                    min_2 = deg_2;
                    l = 1;
                    edges[0] = edges[k];
                } else {
                    if (deg_2 == min_2) {
                        edges[l] = edges[k];
                        l++;
                    }
                }
            }
        }
    }
    *number_of_edges = l;
    return 1;
}

int max_deg_neighbours_cycle(mygraph * h, int * edges, int * number_of_edges, int v, int w) {
    int i, j, k;
    int max_1 = 4;
    int max_2 = 4;
    int sum_1, sum_2;
    int n = h->n;
    int l = 0;
    int sum_1_added_edge = MAX(h->deg[(v + 1) % n] + h->deg[(v - 1 + n) % n], h->deg[(w + 1) % n] + h->deg[(w - 1 + n) % n]);
    int sum_2_added_edge = MIN(h->deg[(v + 1) % n] + h->deg[(v - 1 + n) % n], h->deg[(w + 1) % n] + h->deg[(w - 1 + n) % n]);

    for (k = 0; k<*number_of_edges; k++) {
        i = number_to_edge[edges[k]][0];
        j = number_to_edge[edges[k]][1];
        sum_1 = MAX(h->deg[(i + 1) % n] + h->deg[(i - 1 + n) % n], h->deg[(j + 1) % n] + h->deg[(j - 1 + n) % n]);
        if (sum_1 > sum_1_added_edge) {
            return 0;
        }
        sum_2 = MIN(h->deg[(i + 1) % n] + h->deg[(i - 1 + n) % n], h->deg[(j + 1) % n] + h->deg[(j - 1 + n) % n]);
        if (sum_1 > max_1) {
            max_1 = sum_1;
            max_2 = sum_2;
            l = 1;
            edges[0] = edges[k];
        } else {
            if (sum_1 == sum_1_added_edge && sum_2 > sum_2_added_edge) {
                return 0;
            }
            if (sum_1 == max_1) {
                if (sum_2 > max_2) {
                    max_2 = sum_2;
                    l = 1;
                    edges[0] = edges[k];
                } else {
                    if (sum_2 == max_2) {
                        edges[l] = edges[k];
                        l++;
                    }
                }
            }
        }
    }
    *number_of_edges = l;
    return 1;
}

int min_deg_neighbours_cycle(mygraph * h, int * edges, int * number_of_edges, int v, int w) {
    int i, j, k;
    int sum_1, sum_2;
    int n = h->n;
    int l = 0;
    int sum_1_added_edge = MIN(h->deg[(v + 1) % n] + h->deg[(v - 1 + n) % n], h->deg[(w + 1) % n] + h->deg[(w - 1 + n) % n]);
    int sum_2_added_edge = MAX(h->deg[(v + 1) % n] + h->deg[(v - 1 + n) % n], h->deg[(w + 1) % n] + h->deg[(w - 1 + n) % n]);
    int min_1 = sum_1_added_edge;
    int min_2 = sum_2_added_edge;
    for (k = 0; k<*number_of_edges; k++) {
        i = number_to_edge[edges[k]][0];
        j = number_to_edge[edges[k]][1];
        sum_1 = MIN(h->deg[(i + 1) % n] + h->deg[(i - 1 + n) % n], h->deg[(j + 1) % n] + h->deg[(j - 1 + n) % n]);
        if (sum_1 < sum_1_added_edge) {
            return 0;
        }
        sum_2 = MAX(h->deg[(i + 1) % n] + h->deg[(i - 1 + n) % n], h->deg[(j + 1) % n] + h->deg[(j - 1 + n) % n]);
        if (sum_1 < min_1) {
            min_1 = sum_1;
            min_2 = sum_2;
            l = 1;
            edges[0] = edges[k];
        } else {
            if (sum_1 == sum_1_added_edge && sum_2 < sum_2_added_edge) {
                return 0;
            }
            if (sum_1 == min_1) {
                if (sum_2 < min_2) {
                    min_2 = sum_2;
                    l = 1;
                    edges[0] = edges[k];
                } else {
                    if (sum_2 == min_2) {
                        edges[l] = edges[k];
                        l++;
                    }
                }
            }
        }
    }
    *number_of_edges = l;
    return 1;
}

unsigned long long count_distance_two_vertices(mygraph * h, int v) {
    int i, w;
    unsigned long long vertices = 0;
    //int n = h->n;
    int dv = h->deg[v];
    for (i = 0; i < dv; i++) {
        w = h->neighbours[v][i];
        vertices |= BIT(w);
        vertices |= h->edges[w];
    }
    vertices &= ~BIT(v);
    return vertices;
}

int min_vertices_distance_two(mygraph * h, int * edges, int *number_of_edges, int v, int w) {
    int n = h->n;
    unsigned long long distance_two[n];
    int i, j, k;
    unsigned long long already_counted = 0;
    for (i = 0; i < n; i++) {
        distance_two[i] = 0;
    }
    distance_two[v] = count_distance_two_vertices(h, v);
    distance_two[w] = count_distance_two_vertices(h, w);
    already_counted |= BIT(v);
    already_counted |= BIT(w);
    int vertices_distance_two_inserted_edge = POPC(distance_two[v] || distance_two[w]);
    int l = 0;
    int vertices_distance_two;
    int min_vertices = vertices_distance_two_inserted_edge;
    for (k = 0; k<*number_of_edges; k++) {
        i = number_to_edge[edges[k]][0];
        j = number_to_edge[edges[k]][1];
        if (!(already_counted & BIT(i))) {
            already_counted |= BIT(i);
            distance_two[i] = count_distance_two_vertices(h, i);
        }
        if (!(already_counted & BIT(j))) {
            already_counted |= BIT(j);
            distance_two[j] = count_distance_two_vertices(h, j);
        }
        vertices_distance_two = POPC(distance_two[i] || distance_two[j]);
        if (vertices_distance_two < vertices_distance_two_inserted_edge) {
            return 0;
        }
        if (vertices_distance_two < min_vertices) {
            min_vertices = vertices_distance_two;
            l = 1;
            edges[l] = edges[k];
        } else {
            if (vertices_distance_two == min_vertices) {
                edges[l++] = edges[k];
            }
        }
    }
    *number_of_edges = l;
    return 1;
}

int max_vertices_distance_two(mygraph * h, int * edges, int *number_of_edges, int v, int w) {
    int vertices_distance_two_inserted_edge = POPC(count_distance_two_vertices(h, v) || count_distance_two_vertices(h, w));
    int i, j, k;
    int l = 0;
    int vertices_distance_two;
    int max_vertices = vertices_distance_two_inserted_edge;
    for (k = 0; k<*number_of_edges; k++) {
        i = number_to_edge[edges[k]][0];
        j = number_to_edge[edges[k]][1];
        vertices_distance_two = POPC(count_distance_two_vertices(h, i) || count_distance_two_vertices(h, j));
        if (vertices_distance_two > vertices_distance_two_inserted_edge) {
            return 0;
        }
        if (vertices_distance_two > max_vertices) {
            max_vertices = vertices_distance_two;
            l = 1;
            edges[l] = edges[k];
        } else {
            if (vertices_distance_two == max_vertices) {
                edges[l++] = edges[k];
            }
        }
    }
    *number_of_edges = l;
    return 1;
}

int max_common_neighbours(mygraph * h, int * edges, int * number_of_edges, int v, int w) {
    int k;
    int l = 0;
    //int n = h->n;
    int common_added_edge = POPC(h->edges[v] & h->edges[w]);
    int max = common_added_edge;
    int common;
    for (k = 0; k<*number_of_edges; k++) {
        common = POPC(h->edges[number_to_edge[edges[k]][0]] & h->edges[number_to_edge[edges[k]][1]]);
        if (common > common_added_edge) {
            return 0;
        }
        if (common > max) {
            max = common;
            edges[0] = edges[k];
            l = 1;
        } else {
            if (common == max) {
                edges[l] = edges[k];
                l++;
            }
        }
    }
    *number_of_edges = l;
    return 1;
}

int min_common_neighbours(mygraph * h, int * edges, int * number_of_edges, int v, int w) {
    int k;
    //int n = h->n;
    int common_added_edge = POPC(h->edges[v] & h->edges[w]);
    int min = common_added_edge;
    int common;
    int l = 0;
    for (k = 0; k<*number_of_edges; k++) {
        common = POPC(h->edges[number_to_edge[edges[k]][0]] & h->edges[number_to_edge[edges[k]][1]]);
        if (common < common_added_edge) {
            return 0;
        }
        if (common < min) {
            min = common;
            edges[0] = edges[k];
            l = 1;
        } else {
            if (common == min) {
                edges[l] = edges[k];
                l++;
            }
        }
    }
    *number_of_edges = l;
    return 1;
}

int min_dist_hamcycle_can(mygraph * h, int * edges, int * number_of_edges, int v, int w) {
    int i, j, k;
    int n = h->n;
    int dist_added_edge = MIN(w - v, (v - w + n) % n);
    int min_dist = dist_added_edge;
    int dist;
    int l = 0;
    for (k = 0; k<*number_of_edges; k++) {
        i = number_to_edge[edges[k]][0];
        j = number_to_edge[edges[k]][1];
        dist = MIN(j - i, (i - j + n) % n);
        if (dist < dist_added_edge) {
            return 0;
        }
        if (dist < min_dist) {
            min_dist = dist;
            l = 1;
            edges[0] = edges[k];
        } else {
            if (dist == min_dist) {
                edges[l] = edges[k];
                l++;
            }
        }
    }
    *number_of_edges = l;
    return 1;
}

int max_dist_hamcycle_can(mygraph * h, int * edges, int * number_of_edges, int v, int w) {
    int n = h->n;
    int dist_added_edge = MIN(w - v, (v - w + n) % n);
    int i, j, k;
    int max_dist = 2;
    int l = 0;
    int dist;
    for (k = 0; k<*number_of_edges; k++) {
        i = number_to_edge[edges[k]][0];
        j = number_to_edge[edges[k]][1];
        dist = MIN(j - i, (i - j + n) % n);
        if (dist > dist_added_edge) {
            return 0;
        }
        if (dist > max_dist) {
            max_dist = dist;
            l = 1;
            edges[0] = edges[k];
        } else {
            if (dist == max_dist) {
                edges[l] = edges[k];
                l++;
            }
        }
    }
    *number_of_edges = l;
    return 1;
}

int lex_max_deg_can(mygraph * h, int * possible_edges, int * number_of_possible_edges, int v, int w) {
    //int n = h->n;
    int deg_v = MAX(h->deg[v], h->deg[w]);
    int deg_w = MIN(h->deg[v], h->deg[w]);
    int i, j, k;
    int deg_1, deg_2;
    int max_deg = deg_v;
    int sec_max_deg = deg_w;
    int number_of_edges = 0;

    for (k = 0; k<*number_of_possible_edges; k++) {
        i = number_to_edge[possible_edges[k]][0];
        j = number_to_edge[possible_edges[k]][1];
        deg_1 = MAX(h->deg[i], h->deg[j]);
        deg_2 = MIN(h->deg[i], h->deg[j]);
        if (deg_1 > deg_v) {
            return 0;
        }
        if (deg_1 == deg_v && deg_2 > deg_w) {
            return 0;
        }
        if (deg_1 > max_deg) {
            max_deg = deg_1;
            sec_max_deg = deg_2;
            number_of_edges = 1;
            possible_edges[0] = possible_edges[k];
        } else {
            if (deg_1 == max_deg) {
                if (deg_2 > sec_max_deg) {
                    sec_max_deg = deg_2;
                    number_of_edges = 1;
                    possible_edges[0] = possible_edges[k];
                } else {
                    if (deg_2 == sec_max_deg) {
                        possible_edges[number_of_edges] = possible_edges[k];
                        number_of_edges++;
                    }
                }

            }
        }
    }
    *number_of_possible_edges = number_of_edges;
    return 1;
}

int lex_min_deg_can(mygraph * h, int * possible_edges, int * number_of_possible_edges, int v, int w) {
    //int n = h->n;
    int deg_v = MIN(h->deg[v], h->deg[w]);
    int deg_w = MAX(h->deg[v], h->deg[w]);
    int i, j, k;
    int deg_1, deg_2;
    int min_deg = deg_v;
    int sec_min_deg = deg_w;
    int number_of_edges = 0;

    for (k = 0; k<*number_of_possible_edges; k++) {
        i = number_to_edge[possible_edges[k]][0];
        j = number_to_edge[possible_edges[k]][1];
        deg_1 = MIN(h->deg[i], h->deg[j]);
        deg_2 = MAX(h->deg[i], h->deg[j]);
        if (deg_1 < deg_v) {
            return 0;
        }
        if (deg_1 == deg_v && deg_2 < deg_w) {
            return 0;
        }
        if (deg_1 < min_deg) {
            min_deg = deg_1;
            sec_min_deg = deg_2;
            number_of_edges = 1;
            possible_edges[0] = possible_edges[k];
        } else {
            if (deg_1 == min_deg) {
                if (deg_2 < sec_min_deg) {
                    sec_min_deg = deg_2;
                    number_of_edges = 1;
                    possible_edges[0] = possible_edges[k];
                } else {
                    if (deg_2 == sec_min_deg) {
                        possible_edges[number_of_edges] = possible_edges[k];
                        number_of_edges++;
                    }
                }

            }
        }
    }
    *number_of_possible_edges = number_of_edges;
    return 1;
}

int check_conditions(mygraph * h, int i_can, int j_can, int v, int w) {
    if (!(v == i_can && w == j_can)) {
        return 0;
    }
    if (max_number_of_cycles <= 1) {
        new_cycles = cycle_with_given_edge(h, v, w, max_number_of_cycles - current_number_of_cycles);
        if (new_cycles + current_number_of_cycles > max_number_of_cycles) {
            return 0;
        }
    }
    if (planar) {
        num_graphs_tested_for_planarity++;
        if (!is_planar(h)) {
            num_graphs_rejected_for_planarity++;
            return 0;
        }
    }
    if (no_n_minus_one) {
        if (n_min_one_cycle_with_given_edge(h, v, w, 0)) {
            return 0;
        }
    }
    return 1;
}

void determine_canonical_edge(mygraph * h, int * possible_edges, int number_of_edges, int * i_canonical, int * j_canonical) {
    int n = number_of_vertices;
    int inverse_lab[n];
    int i, j;
    for (i = 0; i < n; i++) {
        inverse_lab[lab[i]] = i;
    }
    //	printArray(inverse_lab,n);
    int i_can, j_can;
    int l, temp;
    i_can = j_can = lab[0];
    int lab_0, lab_1;
    for (l = 0; l < number_of_edges; l++) {
        i = number_to_edge[possible_edges[l]][0];
        j = number_to_edge[possible_edges[l]][1];
        lab_0 = inverse_lab[i];
        lab_1 = inverse_lab[j];
        if (lab_0 > lab_1) {
            temp = lab_0;
            lab_0 = lab_1;
            lab_1 = temp;
        }
        if (lab_1 > inverse_lab[j_can]) {
            j_can = lab[lab_1];
            i_can = lab[lab_0];
        } else {
            if (lab_1 == inverse_lab[j_can]) {
                if (lab_0 > inverse_lab[i_can]) {
                    i_can = lab[lab_0];
                }
            }
        }
    }


    if (i_can > j_can) {
        int temp = i_can;
        i_can = j_can;
        j_can = temp;
    }

    *i_canonical = i_can;
    *j_canonical = j_can;
}

// Bepaal de root van een boog gegeven de lijst met voor elke boog zijn parent

int root_of_edge(int * parent_of_edge, int k) {
    int l = k;
    while (l != parent_of_edge[l]) {
        //		parent_of_edge[l] = parent_of_edge[parent_of_edge[l]]; // Slim idee uit snarkhunter
        l = parent_of_edge[l];
    }
    return l;
}

/*
 * Checkt of twee gegeven bogen in dezelfde orbit zitten.
 * Is bijna hetzelfde als determine_ordbits, maar hier kunnen we al stoppen op het moment dat we de twee roots van de bogen samenvoegen.
 */

int same_orbit(int i_can, int j_can, int v, int w, int * edges, int number_of_edges, int * parent_of_edge, int * tree_size, int n) {
    int p, k, l, r, s;
    int perm[n];
    int e[2];
    int x, y;
    int id, temp;
    int r_can = edge_number[i_can][j_can];
    int r_vw = edge_number[v][w];
    unsigned long long bit_edges[n];
    for (k = 0; k < number_of_edges; k++) {
        bit_edges[number_to_edge[edges[k]][0]] |= BIT(number_to_edge[edges[k]][1]);
    }
    for (p = 0; p < number_of_permutations; p++) {
        memcpy(perm, permutations[p], sizeof (int) * n);
        for (k = 0; k < number_of_edges; k++) {
            /*
             * Neem een boog, beeld hem af met de permutatie, kijk of het beeld ook een van de mogelijke bogen is
             *  als ja: kijk of de root van de nieuwe boog dezelfde is
             * als niet: voeg de twee samen
             */
            id = 0;

            e[0] = number_to_edge[edges[k]][0];
            e[1] = number_to_edge[edges[k]][1];

            x = perm[e[0]];
            y = perm[e[1]];

            while (!id) {
                if (x > y) {
                    temp = x;
                    x = y;
                    y = temp;
                }
                if (x == e[0] && y == e[1]) {
                    id = 1;
                    break;
                }
                l = edge_number[x][y];

                //				if(!(bit_edges[x] & BIT(y))){
                //					bit_edges[x] |= BIT(y);
                //					edges[number_of_edges++] = l;
                //				}

                r = root_of_edge(parent_of_edge, edges[k]);
                s = root_of_edge(parent_of_edge, l);

                if (s != r) {
                    if (tree_size[r] > tree_size[s]) {
                        if (s == r_can) {
                            if (r == r_vw) {
                                return 1;
                            }
                            r_can = r;
                        }
                        if (s == r_vw) {
                            if (r == r_can) {
                                return 1;
                            }
                            r_vw = r;
                        }
                        parent_of_edge[s] = r;
                        tree_size[r] += tree_size[s];
                    } else {
                        if (r == r_can) {
                            if (s == r_vw) {
                                return 1;
                            }
                            r_can = s;
                        }
                        if (r == r_vw) {
                            if (s == r_can) {
                                return 1;
                            }
                            r_vw = s;
                        }
                        parent_of_edge[r] = s;
                        tree_size[s] += tree_size[r];
                    }
                }
                x = perm[x];
                y = perm[y];
            }
        }
    }
    return 0;
}


// Checkt of een gegeven boog canonisch is in de graaf
// Canonisch = lexicografisch grootste boog (voorlopig)

int is_canonical(mygraph * h, int v, int w) {

    number_of_graphs_tested++;

    int n = h->n;
    int i, j, k, l;
    int i_can, j_can;
    int possible_edges[(n * (n - 1)) / 2];
    int number_of_edges = number_of_reducible_edges;
    number_of_changed_cycle_edges = 0;

    memcpy(possible_edges, reducible_edges, sizeof (int)*number_of_reducible_edges);

    new_cycles = 0;
    if (max_number_of_cycles > 1) {
        new_cycles = cycle_with_given_edge(h, v, w, max_number_of_cycles - current_number_of_cycles);
        if (new_cycles + current_number_of_cycles > max_number_of_cycles) {
            reject_by_ham_cycle++;
            return 0;
        }
        if (new_cycles != 0) {
            for (k = 0; k < number_of_hamiltonian_cycles; k++) {
                for (l = 0; l < n; l++) {
                    i = MIN(hamiltonian_cycles[k][l], hamiltonian_cycles[k][(l + 1) % n]);
                    j = MAX(hamiltonian_cycles[k][l], hamiltonian_cycles[k][(l + 1) % n]);
                    if (j == i + 1) {
                        number_of_cycles_through_edge[i]++;
                        changed_cycle_edges[number_of_changed_cycle_edges++] = i;
                    } else {
                        if (i == 0 && j == n - 1) {
                            number_of_cycles_through_edge[n - 1]++;
                            changed_cycle_edges[number_of_changed_cycle_edges++] = n - 1;
                        }
                    }
                }
            }
            number_of_reducible_edges_in_cycle = 0;
            for (i = 0; i < n; i++) {
                if (number_of_cycles_through_edge[i] < new_cycles + current_number_of_cycles) {
                    reducible_edges_in_cycle[number_of_reducible_edges_in_cycle++] = edge_number[i][(i + 1) % n];
                }
            }
        }
    }

    if (max_number_of_cycles > 1) {
        for (i = 0; i < number_of_reducible_edges_in_cycle; i++) {
            possible_edges[number_of_edges++] = reducible_edges_in_cycle[i];
        }
    }

    //	printArray(possible_edges,number_of_edges);

    if (number_of_edges == 1) {
        number_of_graphs_by_criterium[0]++;
        return check_conditions(h, v, w, number_to_edge[possible_edges[0]][0], number_to_edge[possible_edges[0]][1]);
    }

    if (!lex_max_deg_can(h, possible_edges, &number_of_edges, v, w)) {
        number_of_graphs_by_criterium[0]++;
        return 0;
    }

    if (number_of_edges == 1) {
        number_of_graphs_by_criterium[0]++;
        return check_conditions(h, v, w, number_to_edge[possible_edges[0]][0], number_to_edge[possible_edges[0]][1]);
    }

    if (!(triangle_free || square_free)) {
        if (max_number_of_cycles == 1 && !min_dist_hamcycle_can(h, possible_edges, &number_of_edges, v, w)) {
            number_of_graphs_by_criterium[1]++;
            return 0;
        }

        if (number_of_edges == 1) {
            number_of_graphs_by_criterium[1]++;
            return check_conditions(h, v, w, number_to_edge[possible_edges[0]][0], number_to_edge[possible_edges[0]][1]);
        }

        if (max_number_of_cycles == 1 && !min_deg_neighbours_cycle(h, possible_edges, &number_of_edges, v, w)) {
            number_of_graphs_by_criterium[2]++;
            return 0;
        }

        if (number_of_edges == 1) {
            number_of_graphs_by_criterium[2]++;
            return check_conditions(h, v, w, number_to_edge[possible_edges[0]][0], number_to_edge[possible_edges[0]][1]);
        }

        if (max_number_of_cycles == 1 && !min_deg_opposite_nodes(h, possible_edges, &number_of_edges, v, w)) {
            number_of_graphs_by_criterium[3]++;
            return 0;
        }

        if (number_of_edges == 1) {
            number_of_graphs_by_criterium[3]++;
            return check_conditions(h, v, w, number_to_edge[possible_edges[0]][0], number_to_edge[possible_edges[0]][1]);
        }

        if (!max_common_neighbours(h, possible_edges, &number_of_edges, v, w)) {
            number_of_graphs_by_criterium[4]++;
            return 0;
        }

        if (number_of_edges == 1) {
            number_of_graphs_by_criterium[4]++;
            return check_conditions(h, v, w, number_to_edge[possible_edges[0]][0], number_to_edge[possible_edges[0]][1]);
        }

        if (!min_vertices_distance_two(h, possible_edges, &number_of_edges, v, w)) {
            number_of_graphs_by_criterium[5]++;
            return 0;
        }

        if (number_of_edges == 1) {
            number_of_graphs_by_criterium[5]++;
            return check_conditions(h, v, w, number_to_edge[possible_edges[0]][0], number_to_edge[possible_edges[0]][1]);
        }


    } else {
        if (max_number_of_cycles == 1 && !max_dist_hamcycle_can(h, possible_edges, &number_of_edges, v, w)) {
            number_of_graphs_by_criterium[1]++;
            return 0;
        }

        if (number_of_edges == 1) {
            number_of_graphs_by_criterium[1]++;
            return check_conditions(h, v, w, number_to_edge[possible_edges[0]][0], number_to_edge[possible_edges[0]][1]);
        }

        if (!(triangle_free && square_free)) {
            if (max_number_of_cycles == 1 && !min_deg_neighbours_cycle(h, possible_edges, &number_of_edges, v, w)) {
                number_of_graphs_by_criterium[2]++;
                return 0;
            }

            if (number_of_edges == 1) {
                number_of_graphs_by_criterium[2]++;
                return check_conditions(h, v, w, number_to_edge[possible_edges[0]][0], number_to_edge[possible_edges[0]][1]);
            }
            if (triangle_free) {
                if (!min_number_of_squares(h, possible_edges, &number_of_edges, v, w)) {
                    number_of_graphs_by_criterium[3]++;
                    return 0;
                }

                if (number_of_edges == 1) {
                    number_of_graphs_by_criterium[3]++;
                    return check_conditions(h, v, w, number_to_edge[possible_edges[0]][0], number_to_edge[possible_edges[0]][1]);
                }

                if (max_number_of_cycles == 1 && !max_deg_opposite_nodes(h, possible_edges, &number_of_edges, v, w)) {
                    number_of_graphs_by_criterium[4]++;
                    return 0;
                }

                if (number_of_edges == 1) {
                    number_of_graphs_by_criterium[4]++;
                    return check_conditions(h, v, w, number_to_edge[possible_edges[0]][0], number_to_edge[possible_edges[0]][1]);
                }
            } else {
                if (max_number_of_cycles == 1 && !min_deg_opposite_nodes(h, possible_edges, &number_of_edges, v, w)) {
                    number_of_graphs_by_criterium[3]++;
                    return 0;
                }

                if (number_of_edges == 1) {
                    number_of_graphs_by_criterium[3]++;
                    return check_conditions(h, v, w, number_to_edge[possible_edges[0]][0], number_to_edge[possible_edges[0]][1]);
                }
                if (!min_common_neighbours(h, possible_edges, &number_of_edges, v, w)) {
                    number_of_graphs_by_criterium[4]++;
                    return 0;
                }

                if (number_of_edges == 1) {
                    number_of_graphs_by_criterium[4]++;
                    return check_conditions(h, v, w, number_to_edge[possible_edges[0]][0], number_to_edge[possible_edges[0]][1]);
                }
            }
        } else {
            if (max_number_of_cycles == 1 && !min_deg_opposite_nodes(h, possible_edges, &number_of_edges, v, w)) {
                number_of_graphs_by_criterium[2]++;
                return 0;
            }

            if (number_of_edges == 1) {
                number_of_graphs_by_criterium[2]++;
                return check_conditions(h, v, w, number_to_edge[possible_edges[0]][0], number_to_edge[possible_edges[0]][1]);
            }

            if (max_number_of_cycles == 1 && !min_deg_neighbours_cycle(h, possible_edges, &number_of_edges, v, w)) {
                number_of_graphs_by_criterium[3]++;
                return 0;
            }

            if (number_of_edges == 1) {
                number_of_graphs_by_criterium[3]++;
                return check_conditions(h, v, w, number_to_edge[possible_edges[0]][0], number_to_edge[possible_edges[0]][1]);
            }
            if (!min_vertices_distance_two(h, possible_edges, &number_of_edges, v, w)) {
                number_of_graphs_by_criterium[4]++;
                return 0;
            }

            if (number_of_edges == 1) {
                number_of_graphs_by_criterium[4]++;
                return check_conditions(h, v, w, number_to_edge[possible_edges[0]][0], number_to_edge[possible_edges[0]][1]);
            }
        }
    }

    if (no_n_minus_one) {
        if (n_min_one_cycle_with_given_edge(h, v, w, 0)) {
            return 0;
        }
    }

    if (max_number_of_cycles <= 1) {
        new_cycles = cycle_with_given_edge(h, v, w, max_number_of_cycles - current_number_of_cycles);
        if (new_cycles + current_number_of_cycles > max_number_of_cycles) {
            reject_by_ham_cycle++;
            return 0;
        }
    }

    //	if(new_cycles != 0){
    //		for(k=0;k<number_of_hamiltonian_cycles;k++){
    //			for(l=0;l<n;l++){
    //				i = MIN(hamiltonian_cycles[k][l],hamiltonian_cycles[k][(l+1)%n]);
    //				j = MAX(hamiltonian_cycles[k][l],hamiltonian_cycles[k][(l+1)%n]);
    //				if(j == i+1){
    //					number_of_cycles_through_edge[i]++;
    //					changed_cycle_edges[number_of_changed_cycle_edges++] = i;
    //				}else{
    //					if(i==0 && j == n-1){
    //						number_of_cycles_through_edge[n-1]++;
    //						changed_cycle_edges[number_of_changed_cycle_edges++] = n-1;
    //					}
    //				}
    //			}
    //		}
    //		number_of_reducible_edges_in_cycle = 0;
    //		for(i=0;i<n;i++){
    //			if(number_of_cycles_through_edge[i] < new_cycles + current_number_of_cycles){
    //				reducible_edges_in_cycle[number_of_reducible_edges_in_cycle++] = edge_number[i][(i+1)%n];
    //			}
    //		}
    //	}

    number_of_nauty_calls++;

    get_canonical_labeling(h);


    determine_canonical_edge(h, possible_edges, number_of_edges, &i_can, &j_can);

    //	if(max_number_of_cycles > 1){
    //		for(i=0;i<number_of_reducible_edges_in_cycle;i++){
    //			possible_edges[number_of_edges++] = reducible_edges_in_cycle[i];
    //		}
    //	}

    //	number_of_edges_before_nauty_call *= (number_of_nauty_calls -1);
    //	number_of_edges_before_nauty_call += number_of_edges;
    //	number_of_edges_before_nauty_call /= number_of_nauty_calls;

    if (i_can == v && j_can == w) {
        if (planar) {
            num_graphs_tested_for_planarity++;
            if (!is_planar(h)) {
                return 0;
            }
        }
        nauty_called = 1;
        return 1;
    }

    //	if(new_cycles + current_number_of_cycles > 1){
    //		for(i=0;i<n;i++){
    //			possible_edges[number_of_edges] = edges_in_cycle[i];
    //			number_of_edges++;
    //		}
    //	}

    for (k = 0; k < number_of_edges; k++) {
        parent_of_edge[possible_edges[k]] = possible_edges[k];
        tree_size_of_root[possible_edges[k]] = 1;
    }

    if (same_orbit(i_can, j_can, v, w, possible_edges, number_of_edges, parent_of_edge, tree_size_of_root, n)) {
        if (planar) {
            num_graphs_tested_for_planarity++;
            if (!is_planar(h)) {
                return 0;
            }
        }
        nauty_called = 1;
        return 1;
    }
    number_of_non_canonical_edges++;
    return 0;
}

// Bepaal alle orbits

void determine_orbits(int * edges, int number_of_edges, int * parent_of_edge, int * tree_size, int n) {
    int p, k, l, r, s;
    int perm[n];
    int e[2];
    int x, y;
    int id, temp;
    int number_of_orbits = number_of_edges;
    for (p = 0; p < number_of_permutations; p++) {
        if (number_of_orbits == 1) {
            break;
        }
        memcpy(perm, permutations[p], sizeof (int) * n);
        //		printArray(perm,n);
        for (k = 0; k < number_of_edges; k++) {
            if (number_of_orbits == 1) {
                break;
            }
            /*
             * Neem een boog, beeld hem herhaaldelijk af met de permutatie tot je weer terug bent bij de oorspronkelijke boog.
             * Voeg orbits telkens samen als ze een verschillende root hebben.
             */
            id = 0;

            e[0] = number_to_edge[edges[k]][0];
            e[1] = number_to_edge[edges[k]][1];

            x = perm[e[0]];
            y = perm[e[1]];
            while (!id) {
                if (x > y) {
                    temp = x;
                    x = y;
                    y = temp;
                }
                if (x == e[0] && y == e[1]) {
                    id = 1;
                    break;
                }

                l = edge_number[x][y];
                r = root_of_edge(parent_of_edge, edges[k]);
                s = root_of_edge(parent_of_edge, l);

                if (s != r) {
                    //					printf("%d-%d en %d-%d in zelfde orbit\n",e[0],e[1],x,y);
                    if (tree_size[r] > tree_size[s]) {
                        parent_of_edge[s] = r;
                        tree_size[r] += tree_size[s];
                    } else {
                        parent_of_edge[r] = s;
                        tree_size[s] += tree_size[r];
                    }
                    number_of_orbits--;
                }
                x = perm[x];
                y = perm[y];
            }
        }
    }
}

void get_generators(mygraph * h) {
    number_of_permutations = 0;
    options.getcanon = FALSE;
    if (!converted_to_sg) {
        mygraph_to_sg(&sg, h);
    }
    converted_to_sg = 1;
    sparsenauty(&sg, lab, ptn, orbits, &options, &stats, &canonsg);
}


int has_reducible_nbr_with_larger_deg(mygraph * h, int vertex1, int second_degree) {
    
    int n = h->n;
    
    int i;
    for(i = 0; i < h->deg[vertex1]; i++) {
        int neighbour = h->neighbours[vertex1][i];
        //All edges are red if max num cycles == 0
        //If 1 cycle: only the edges from the first cycle are irred
        if(h->deg[neighbour] > second_degree 
                && (max_number_of_cycles == 0 || !(neighbour == (vertex1 + 1) % n || vertex1 == (neighbour + 1) % n)))
            return 1;
    }
    
    return 0;
}

/*
 * Haalt uit gegeven lijst van bogen die met lexicografisch hoogste graden van toppen
 */

void lex_max_degree(mygraph * h, int * edges, int * number_of_edges) {
    int list_edges[*number_of_edges];
    memcpy(list_edges, edges, sizeof (int) * (*number_of_edges));
    int k, i, j, deg_max, deg_min, deg_i, deg_j;
    int max_deg = 0;
    int sec_max_deg = 0;
    int n = h->n;
    int l = 0;
    // Zoek huidige maximale graad
    for (i = 0; i < n; i++) {
        deg_i = h->deg[i];
        if (deg_i > max_deg) {
            max_deg = deg_i;
            sec_max_deg = 0;
            for (j = 0; j < deg_i; j++) {
                k = h->neighbours[i][j];
                //No breaks everything!!
                //if (max_number_of_cycles > 0 && (k == (i + 1) % n || i == (k + 1) % n)) {
                //    break;
                //}
                if (max_number_of_cycles > 0 && (k == (i + 1) % n || i == (k + 1) % n)) {
                    continue; //Use continue instead of break!!!
                }
                deg_j = h->deg[k];
                //if (deg_j > deg_i) {
                //    break; //Was no problem to break here since other case where i := j is also done
                //}
                if (deg_j > sec_max_deg && deg_j <= deg_i) {
                    sec_max_deg = deg_j;
                }                
            }
        }
    }
    // Kijk of een boog door toevoeging maximale graad kan hebben
    for (k = 0; k < (*number_of_edges); k++) {
        i = number_to_edge[list_edges[k]][0];
        j = number_to_edge[list_edges[k]][1];
        int vertex_min_deg, vertex_max_deg;
        if(h->deg[i] > h->deg[j]) {
            deg_max = h->deg[i];
            vertex_max_deg = i;
            deg_min = h->deg[j];
            vertex_min_deg = j;
        } else {
            deg_max = h->deg[j];
            vertex_max_deg = j;
            deg_min = h->deg[i];
            vertex_min_deg = i;            
        }
        
        //This helps a lot: 30% speedup and increasing
        if(has_reducible_nbr_with_larger_deg(h, vertex_max_deg, deg_min + 1)) {
            continue; //i.e. edge cannot be canonical!
        }
        
        //deg_1 = MAX(h->deg[i], h->deg[j]);
        //deg_2 = MIN(h->deg[i], h->deg[j]);
        if (deg_max + 1 == max_deg) {
            if (deg_min + 1 >= sec_max_deg) {
                edges[l] = list_edges[k];
                l++;
            }
        } else {
            if (deg_max + 1 > max_deg) {
                edges[l] = list_edges[k];
                l++;
            }
        }
    }
    *number_of_edges = l;
}


int check_print() {
    if (modulo && rest != 0 && number_of_reducible_edges < splitlevel) {
        return 0;
    }
    if (output_exact && current_number_of_cycles != max_number_of_cycles) {
        return 0;
    }
    if (maxdeg != number_of_vertices) {
        if (!current_number_of_nodes_maxdeg) {
            return 0;
        }
    }
    if (max_number_of_nodes_maxdeg != number_of_vertices + 1) {
        if (max_number_of_nodes_maxdeg != current_number_of_nodes_maxdeg) {
            return 0;
        }
    }
    return 1;
}

// Grote recursieve methode om graaf uit te breiden met canonische bogen

void expand(mygraph * h) {

    if (modulo && number_of_reducible_edges == splitlevel) {
        splitlevel_counter++;
        if (splitlevel_counter == mod) {
            splitlevel_counter = 0;
        }
        if (splitlevel_counter != rest) {
            nauty_called = 0;
            return;
        }
    }

    //	number_of_graphs_generated++;
    //	print_graph6(h);
    if (check_print()) {
        if (max_number_of_cycles == 0) {
            number_of_graphs_with_given_num_edges[number_of_reducible_edges]++;
        } else {
            number_of_graphs_with_given_num_edges[number_of_reducible_edges + number_of_vertices]++;
        }
        output_graph_g6(h);
    }

    //	if(h->e == max_edges(h->n)){
    //		number_of_times_max_edges++;
    //		return;
    //	}

    //	Zoek toe te voegen bogen

    int n = number_of_vertices;
    int i, j, k;
    int l = 0;
    int possible_edges[(n * (n - 1)) / 2];
    int number_of_possible_edges = 0;
    int removed_edges[(n * (n - 1)) / 2];
    int number_of_removed_edges = 0;

    for (k = 0; k < number_of_edges_to_add; k++) {
        i = number_to_edge[possible_edges_to_add[k]][0];
        j = number_to_edge[possible_edges_to_add[k]][1];
        if (allowed_to_add(h, i, j)) {
            possible_edges[number_of_possible_edges] = possible_edges_to_add[k];
            possible_edges_to_add[l++] = possible_edges_to_add[k];
            number_of_possible_edges++;
        } else {
            removed_edges[number_of_removed_edges++] = possible_edges_to_add[k];
        }
    }

    number_of_edges_to_add = l;

    if (max_number_of_cycles <= 1) {
        lex_max_degree(h, possible_edges, &number_of_possible_edges);
    }

    if (number_of_possible_edges == 0) {
        nauty_called = 0;
        for (i = 0; i < number_of_removed_edges; i++) {
            possible_edges_to_add[number_of_edges_to_add++] = removed_edges[i];
        }
        return;
    }

    /*
     * Juiste variabelen aanmaken om mee te geven met determine_orbits
     * De bedoeling is om op het einde een lijst met roots over te hebben
     */

    int parent_of_edge[(n * (n - 1)) / 2];
    int tree_size_of_root[(n * (n - 1)) / 2];

    for (i = 0; i < number_of_possible_edges; i++) {
        k = possible_edges[i];
        tree_size_of_root[k] = 1;
        parent_of_edge[k] = k;
    }

    if (number_of_possible_edges != 1) {
        if (!nauty_called) {
            get_generators(h);
        }
        determine_orbits(possible_edges, number_of_possible_edges, parent_of_edge, tree_size_of_root, n);
    }
    nauty_called = 0;

    /*
     * We willen uit elke orbit één boog toevoegen uit possible edges. We nemen een edge, kijken naar de root
     * en kijken of we al een boog hebben toegevoegd met die root (we kijken in bitvectoren of de root er nog is).
     * Als we een root heben gehad verwijderen we hem uit de bitvectoren.
     *
     * We voegen een boog toe, kijken eerst of er een nieuwe ham. cykel is bijgekomen. Als niet: kijk of hij canonisch is.
     * Voeg toe en expand als hij canonisch is.
     */

    int e[2];
    int r;
    int number_of_cycles_temp;
    int cycles_through_edges_temp[n];
    int number_of_reducible_edges_in_cycle_temp;
    int reducible_edges_in_cycle_temp[n];
    int temp_maxdeg;
    int possible_edges_to_add_temp[n * (n - 1) / 2];
    //

    for (i = 0; i < number_of_possible_edges; i++) {

        if (parent_of_edge[possible_edges[i]] == possible_edges[i]) {

            e[0] = number_to_edge[possible_edges[i]][0];
            e[1] = number_to_edge[possible_edges[i]][1];

            temp_maxdeg = 0;

            add_edge(h, e[0], e[1]);

            reducible_edges[number_of_reducible_edges++] = possible_edges[i];

            if (h->deg[e[0]] == maxdeg) {
                temp_maxdeg++;
                current_number_of_nodes_maxdeg++;
            }
            if (h->deg[e[1]] == maxdeg) {
                temp_maxdeg++;
                current_number_of_nodes_maxdeg++;
            }
            if (max_number_of_nodes_maxdeg >= current_number_of_nodes_maxdeg) {

                converted_to_sg = 0;
                if (max_number_of_cycles > 1) {
                    memcpy(cycles_through_edges_temp, number_of_cycles_through_edge, sizeof (int)*n);
                    memcpy(reducible_edges_in_cycle_temp, reducible_edges_in_cycle, sizeof (int)*number_of_reducible_edges_in_cycle);
                    number_of_reducible_edges_in_cycle_temp = number_of_reducible_edges_in_cycle;
                }
                number_of_cycles_temp = current_number_of_cycles;
                if (is_canonical(h, e[0], e[1])) {

                    current_number_of_cycles += new_cycles;

                    //				printf("edge added %d-%d\n",e[0],e[1]);

                    if (modulo) {
                        memcpy(possible_edges_to_add_temp, possible_edges_to_add, sizeof (int)*number_of_edges_to_add);
                    }

                    expand(h);

                    current_number_of_cycles = number_of_cycles_temp;

                    if (modulo) {
                        memcpy(possible_edges_to_add, possible_edges_to_add_temp, sizeof (int)*number_of_edges_to_add);
                    }

                }
                if (max_number_of_cycles > 1) {
                    memcpy(number_of_cycles_through_edge, cycles_through_edges_temp, sizeof (int)*n);
                    memcpy(reducible_edges_in_cycle, reducible_edges_in_cycle_temp, sizeof (int)*number_of_reducible_edges_in_cycle_temp);
                    number_of_reducible_edges_in_cycle = number_of_reducible_edges_in_cycle_temp;
                }
            }
            current_number_of_nodes_maxdeg = current_number_of_nodes_maxdeg - temp_maxdeg;
            remove_last_edge(h, e[0], e[1]);
            number_of_reducible_edges--;
        }
    }
    for (i = 0; i < number_of_removed_edges; i++) {
        possible_edges_to_add[number_of_edges_to_add++] = removed_edges[i];
    }
}

void generate() {
    if (number_of_vertices <= 2 && max_number_of_cycles > 0) {
        return;
    }
    if (triangle_free && number_of_vertices == 3 && max_number_of_cycles > 0) {
        return;
    }
    if (square_free && number_of_vertices == 4 && max_number_of_cycles > 0) {
        return;
    }
    /*
     * Initialisatie van sommige dingen
     */
    determine_edge_numbers(number_of_vertices);
    options.userautomproc = save_generators;
    initialize_graphs(number_of_vertices);
    m = SETWORDSNEEDED(number_of_vertices);
    nauty_check(WORDSIZE, m, number_of_vertices, NAUTYVERSIONID);

    /*
     * Maak cykel met n toppen, print uit en expand
     */

    mygraph h;

    int i, j;

    if (max_number_of_cycles > 0) {
        h = cycle_graph(number_of_vertices);
        number_of_edges_to_add = 0;
        for (j = 2; j < number_of_vertices - 1; j++) {
            possible_edges_to_add[number_of_edges_to_add] = edge_number[0][j];
            number_of_edges_to_add++;
        }
        for (i = 1; i < number_of_vertices; i++) {
            for (j = (i + 2); j < number_of_vertices; j++) {
                possible_edges_to_add[number_of_edges_to_add] = edge_number[i][j];
                number_of_edges_to_add++;
            }
        }
        for (i = 0; i < number_of_vertices; i++) {
            edges_in_cycle[i] = edge_number[i][(i + 1) % number_of_vertices];
            bit_cycle[i] = BIT((i + 1) % number_of_vertices);
            bit_cycle[(i + 1) % number_of_vertices] = BIT(i);
        }
        for (i = 0; i < number_of_vertices; i++) {
            number_of_cycles_through_edge[i] = 1;
        }
        current_number_of_cycles = 1;
        //print_mygraph(h);
        //print_mygraph_adjlist(h);

    } else {
        h = emptygraph(number_of_vertices);
        for (i = 0; i < number_of_vertices; i++) {
            for (j = (i + 1); j < number_of_vertices; j++) {
                possible_edges_to_add[number_of_edges_to_add] = edge_number[i][j];
                number_of_edges_to_add++;
            }
        }
        current_number_of_cycles = 0;
    }
    
    number_of_reducible_edges = 0;
    number_of_graphs_written = 0;
    nauty_called = 0;
    converted_to_sg = 0;
    number_of_reducible_edges_in_cycle = 0;
    //
    expand(&h);
}